package threadpallina;

import java.awt.Dimension;
import java.awt.event.MouseAdapter;
import java.awt.event.MouseEvent;

import javax.swing.ImageIcon;
import javax.swing.JLabel;
import javax.swing.JPanel;

public class JPallina extends JLabel implements Runnable {

	private final int SPEED = 5;
	private int vx = SPEED, vy = SPEED;
	private boolean running = false;

	public JPallina() {
		setPreferredSize(new Dimension(10, 10));
		setIcon(new ImageIcon(JPallina.class.getResource("/threadpallina/img/pallina.png")));
		addMouseListener(new MouseAdapter() {
			@Override
			public void mouseClicked(MouseEvent e) {
				if (running)
					stop();
				else
					start();
			}
		});
	}

	public void start() {
		if (!running) {
			running = true;
			Thread t = new Thread(this);
			t.setDaemon(true);
			t.start();
		}
	}

	public void stop() {
		running = false;
	}

	public void reset() {
		vx = SPEED;
		vy = SPEED;
		this.setLocation(0, 0);
	}

	@Override
	public void run() {
		while (running) {
			int x = this.getX(), y = this.getY();

			JPanel pnlSfondo = (JPanel) this.getParent();
			int xMax = pnlSfondo.getWidth() - 1 - this.getWidth();
			int yMax = pnlSfondo.getHeight() - 1 - this.getHeight();

			x += vx;
			if (x <= 0) {
				x = -x;
				vx = +SPEED;
			}
			if (x >= xMax) {
				x = -x + 2 * xMax;
				vx = -SPEED;
			}
			y += vy;
			if (y <= 0) {
				y = -y;
				vy = +SPEED;
			}
			if (y >= yMax) {
				y = -y + 2 * yMax;
				vy = -SPEED;
			}
			this.setLocation(x, y);
			try {
				Thread.sleep(20);
			} catch (InterruptedException e) {
			}
		}
	}

}
